// Java class com.proton.gopenpgp.crypto.ClearTextMessage is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/gopenpgp/v2/crypto
//
// File is generated by gobind. Do not edit.
package com.proton.gopenpgp.crypto;

import go.Seq;

/**
 * ClearTextMessage, split signed clear text message container.
A Cleartext message is a signed PGP message, that is not encrypted,
i.e. the ones beginning with -----BEGIN PGP SIGNED MESSAGE-----
 */
public final class ClearTextMessage implements Seq.Proxy {
	static { Crypto.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewClearTextMessage generates a new ClearTextMessage from data and signature
	 */
	public ClearTextMessage(byte[] data, byte[] signature) {
		this.refnum = __NewClearTextMessage(data, signature);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewClearTextMessage(byte[] data, byte[] signature);
	
	/**
	 * NewClearTextMessageFromArmored returns the message body and unarmored signature from a clearsigned message.
	 */
	public ClearTextMessage(String signedMessage) {
		this.refnum = __NewClearTextMessageFromArmored(signedMessage);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewClearTextMessageFromArmored(String signedMessage);
	
	ClearTextMessage(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	public final native byte[] getData();
	public final native void setData(byte[] v);
	
	public final native byte[] getSignature();
	public final native void setSignature(byte[] v);
	
	/**
	 * GetArmored armors plaintext and signature with the PGP SIGNED MESSAGE armoring
	 */
	public native String getArmored() throws Exception;
	/**
	 * GetBinary returns the unarmored signed data as a []byte
	 */
	public native byte[] getBinary();
	/**
	 * GetBinarySignature returns the unarmored binary signature as a []byte
	 */
	public native byte[] getBinarySignature();
	/**
	 * GetString returns the unarmored signed data as a string
	 */
	public native String getString();
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof ClearTextMessage)) {
		    return false;
		}
		ClearTextMessage that = (ClearTextMessage)o;
		byte[] thisData = getData();
		byte[] thatData = that.getData();
		if (thisData == null) {
			if (thatData != null) {
			    return false;
			}
		} else if (!thisData.equals(thatData)) {
		    return false;
		}
		byte[] thisSignature = getSignature();
		byte[] thatSignature = that.getSignature();
		if (thisSignature == null) {
			if (thatSignature != null) {
			    return false;
			}
		} else if (!thisSignature.equals(thatSignature)) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getData(), getSignature()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("ClearTextMessage").append("{");
		b.append("Data:").append(getData()).append(",");
		b.append("Signature:").append(getSignature()).append(",");
		return b.append("}").toString();
	}
}

