// Java class com.proton.gopenpgp.crypto.Key is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/gopenpgp/v2/crypto
//
// File is generated by gobind. Do not edit.
package com.proton.gopenpgp.crypto;

import go.Seq;

/**
 * Key contains a single private or public key
 */
public final class Key implements Seq.Proxy {
	static { Crypto.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewKey creates a new key from the first key in the unarmored binary data
	 */
	public Key(byte[] binKeys) {
		this.refnum = __NewKey(binKeys);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewKey(byte[] binKeys);
	
	/**
	 * NewKeyFromArmored creates a new key from the first key in an armored
	 */
	public Key(String armored) {
		this.refnum = __NewKeyFromArmored(armored);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewKeyFromArmored(String armored);
	
	// skipped constructor Key.NewKeyFromArmoredReader with unsupported parameter or return types
	
	// skipped constructor Key.NewKeyFromReader with unsupported parameter or return types
	
	Key(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	public native String armor() throws Exception;
	/**
	 * Check verifies if the public keys match the private key parameters by signing and verifying
	 */
	public native boolean check() throws Exception;
	public native boolean clearPrivateParams();
	/**
	 * Copy creates a deep copy of the key.
	 */
	public native Key copy() throws Exception;
	/**
	 * GetArmoredPublicKey returns the armored public keys from this keyring.
	 */
	public native String getArmoredPublicKey() throws Exception;
	/**
	 * GetFingerprint gets the fingerprint from the key
	 */
	public native String getFingerprint();
	/**
	 * GetHexKeyID returns the key ID, hex encoded as a string
	 */
	public native String getHexKeyID();
	// skipped method Key.GetKeyID with unsupported parameter or return types
	
	/**
	 * GetPublicKey returns the unarmored public keys from this keyring.
	 */
	public native byte[] getPublicKey() throws Exception;
	/**
	 * IsExpired checks whether the key is expired.
	 */
	public native boolean isExpired();
	/**
	 * IsLocked checks if a private key is locked
	 */
	public native boolean isLocked() throws Exception;
	/**
	 * IsPrivate returns true if the key is private
	 */
	public native boolean isPrivate();
	/**
	 * IsUnlocked checks if a private key is unlocked
	 */
	public native boolean isUnlocked() throws Exception;
	/**
	 * Lock locks a copy of the key.
	 */
	public native Key lock(byte[] passphrase) throws Exception;
	/**
	 * PrintFingerprints is a debug helper function that prints the key and subkey fingerprints.
	 */
	public native void printFingerprints();
	public native byte[] serialize() throws Exception;
	/**
	 * Unlock unlocks a copy of the key
	 */
	public native Key unlock(byte[] passphrase) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Key)) {
		    return false;
		}
		Key that = (Key)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Key").append("{");
		return b.append("}").toString();
	}
}

